/**
 *	1.6.0
 *		- Changed cvar default values.
 *		- Added support for custom models.
 *		- Added model cvars.
 *		- Added message cvars.
 *		- Merged Win or Die cvars.
 *		- Fixed menu handle.
 *		- Cleaned some code.
 */

#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <cstrike>

#define PLUGIN_VERSION "1.6.0"

#define CHICKEN		"models/chicken/chicken.mdl"
#define FEATHERS	"models/chicken/chicken_gone.mdl"

#define TEAM_T	2
#define TEAM_CT	3

new String:playerName[32],
	bool:clutch = false, bool:cluck = false, bool:displayed = false, bool:roundend = false, bool:tp = false, bool:tpOld = false,
	playerId = 0, chickenId = 0, chickenIdOld = 0, lastButton = 0, lastButtonOld = 0,
	savedTime, roundTime, aliveT, aliveCT, rivals;
	
new Handle:sm_coc_enable		= INVALID_HANDLE,
	Handle:sm_coc_random		= INVALID_HANDLE,
	Handle:sm_coc_ratio			= INVALID_HANDLE,
	Handle:sm_coc_beacon		= INVALID_HANDLE,
	Handle:sm_coc_knife			= INVALID_HANDLE,
	Handle:sm_coc_c4pickup		= INVALID_HANDLE,
	Handle:sm_coc_thirdperson	= INVALID_HANDLE,
	Handle:sm_coc_slaytk		= INVALID_HANDLE,
	Handle:sm_coc_winordie		= INVALID_HANDLE,
	Handle:sm_coc_hpchicken		= INVALID_HANDLE,
	Handle:sm_coc_hpbonus		= INVALID_HANDLE,
	Handle:sm_coc_hpreward		= INVALID_HANDLE,
	Handle:sm_coc_burntime		= INVALID_HANDLE,
	Handle:sm_coc_timeleft		= INVALID_HANDLE,
	Handle:sm_coc_minrivals		= INVALID_HANDLE,
	Handle:sm_coc_maxrivals		= INVALID_HANDLE,
	Handle:sm_coc_mdl_cluckct	= INVALID_HANDLE,
	Handle:sm_coc_mdl_cluckt	= INVALID_HANDLE,
	Handle:sm_coc_mdl_clutchct	= INVALID_HANDLE,
	Handle:sm_coc_mdl_clutcht	= INVALID_HANDLE,
	Handle:sm_coc_msg_warn		= INVALID_HANDLE,
	Handle:sm_coc_msg_killdeath	= INVALID_HANDLE,
	Handle:sm_coc_msg_clutch	= INVALID_HANDLE,
	Handle:sm_coc_msg_windordie	= INVALID_HANDLE,
	Handle:sm_coc_version		= INVALID_HANDLE;

new String:cluckCT[128], String:cluckT[128], String:clutchCT[128], String:clutchT[128],
	bool:cocenable, bool:random, bool:knife, bool:c4pickup, bool:thirdperson, bool:slaytk, bool:mWarn, bool:mKillDeath, bool:mClutch, bool:mWinOrDie,
	ratio, beacon, winordie, hpchicken, hpbonus, hpreward, timeleft, minrivals, maxrivals,
	Float:burntime;

new EngineVersion:g_EngineVersion;

public Plugin:myinfo = 
{
	name = "[CS:GO/CS:S] Clutch Or Cluck",
	author = "GabenNewell (Bad Kitty)",
	description = "Clutch now or cluck the next round.",
	version = PLUGIN_VERSION,
	url = "https://forums.alliedmods.net/showthread.php?t=237554"
};

public OnPluginStart()
{
	RegAdminCmd("sm_chicken", Command_Chicken, ADMFLAG_SLAY, "Sets the model of a player to a chicken.");
	
	sm_coc_enable			= CreateConVar("sm_coc_enable",			"1",	"Enable/disable the plugin.",																				FCVAR_PLUGIN, true, 0.0,	true, 1.0);
	sm_coc_random			= CreateConVar("sm_coc_random",			"0",	"Randomly set Clutch or Cluck based on a ratio.",															FCVAR_PLUGIN, true, 0.0,	true, 1.0);
	sm_coc_ratio			= CreateConVar("sm_coc_ratio",			"50",	"Percentage (%) chance for the player to turn into a chicken if sm_coc_random is 1. (100 = Always)",		FCVAR_PLUGIN, true, 0.0,	true, 100.0);
	sm_coc_beacon			= CreateConVar("sm_coc_beacon",			"0",	"Sets beacon on the player. (0 = Disabled, 1 = Clutch, 2 = Cluck, 3 = Both)\n* Requires funcommands.smx",	FCVAR_PLUGIN, true, 0.0,	true, 3.0);
	sm_coc_knife			= CreateConVar("sm_coc_knife",			"1",	"Allow chickens to use a knife.",																			FCVAR_PLUGIN, true, 0.0,	true, 1.0);
	sm_coc_c4pickup			= CreateConVar("sm_coc_c4pickup",		"1",	"Allow chickens to pick up and plant the bomb.",															FCVAR_PLUGIN, true, 0.0,	true, 1.0);
	sm_coc_thirdperson		= CreateConVar("sm_coc_thirdperson",	"1",	"Allow chickens to toggle third-person view using reload key. (CS:GO only)",								FCVAR_PLUGIN, true, 0.0,	true, 1.0);
	sm_coc_slaytk			= CreateConVar("sm_coc_slaytk",			"1",	"Slay players who team kill friendly chickens.",															FCVAR_PLUGIN, true, 0.0,	true, 1.0);
	sm_coc_winordie			= CreateConVar("sm_coc_winordie",		"50",	"If non-zero, slays players of the losing team whose HP is greater than or equal to this value.",			FCVAR_PLUGIN, true, 0.0,	true, 5000.0);
	sm_coc_hpchicken		= CreateConVar("sm_coc_hpchicken",		"1",	"Health points when turned into a chicken.",																FCVAR_PLUGIN, true, 1.0,	true, 5000.0);
	sm_coc_hpbonus			= CreateConVar("sm_coc_hpbonus",		"500",	"Health points when attempting to clutch a round.",															FCVAR_PLUGIN, true, 1.0,	true, 5000.0);
	sm_coc_hpreward			= CreateConVar("sm_coc_hpreward",		"200",	"Health points for successfully clutching a round.",														FCVAR_PLUGIN, true, 1.0,	true, 1000.0);
	sm_coc_burntime 		= CreateConVar("sm_coc_burntime",		"60.0",	"Number of seconds to burn a player for not clutching.",													FCVAR_PLUGIN, true, 0.0,	true, 120.0);
	sm_coc_timeleft 		= CreateConVar("sm_coc_timeleft",		"20",	"Minimum number of seconds left in a round for Clutch Or Cluck to activate.",								FCVAR_PLUGIN, true, 10.0,	true, 240.0);
	sm_coc_minrivals		= CreateConVar("sm_coc_minrivals",		"5",	"Minimum number of rivals for Clutch Or Cluck to activate.",												FCVAR_PLUGIN, true, 1.0,	true, 40.0);
	sm_coc_maxrivals		= CreateConVar("sm_coc_maxrivals",		"20",	"Maximum number of rivals for Clutch Or Cluck to activate.",												FCVAR_PLUGIN, true, 1.0,	true, 40.0);
	sm_coc_mdl_cluckct		= CreateConVar("sm_coc_mdl_cluckct",	"models/chicken/chicken.mdl",	"Cluck model for Counter-Terrorists.",												FCVAR_PLUGIN);
	sm_coc_mdl_cluckt		= CreateConVar("sm_coc_mdl_cluckt",		"models/chicken/chicken.mdl",	"Cluck model for Terrorists.",														FCVAR_PLUGIN);
	sm_coc_mdl_clutchct		= CreateConVar("sm_coc_mdl_clutchct",	"",								"Clutch model for Counter-Terrorists.",												FCVAR_PLUGIN);
	sm_coc_mdl_clutcht		= CreateConVar("sm_coc_mdl_clutcht",	"",								"Clutch model for Terrorists.",														FCVAR_PLUGIN);
	sm_coc_msg_warn			= CreateConVar("sm_coc_msg_warn",		"1",	"Show warning when Clutch or Cluck has been set on a player.",												FCVAR_PLUGIN, true, 0.0,	true, 1.0);
	sm_coc_msg_killdeath	= CreateConVar("sm_coc_msg_killdeath",	"1",	"Show chicken kill/death notifications.",																	FCVAR_PLUGIN, true, 0.0,	true, 1.0);
	sm_coc_msg_clutch		= CreateConVar("sm_coc_msg_clutch",		"1",	"Show clutch round information.",																			FCVAR_PLUGIN, true, 0.0,	true, 1.0);
	sm_coc_msg_windordie	= CreateConVar("sm_coc_msg_windordie",	"1",	"Show win or die team slay message.",																		FCVAR_PLUGIN, true, 0.0,	true, 1.0);
	sm_coc_version			= CreateConVar("sm_coc_version",		PLUGIN_VERSION,	"Clutch Or Cluck plugin version.",																	FCVAR_PLUGIN|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	
	HookConVarChange(sm_coc_enable,			ConVarChange);
	HookConVarChange(sm_coc_random,			ConVarChange);
	HookConVarChange(sm_coc_ratio,			ConVarChange);
	HookConVarChange(sm_coc_beacon,			ConVarChange);
	HookConVarChange(sm_coc_knife,			ConVarChange);
	HookConVarChange(sm_coc_c4pickup,		ConVarChange);
	HookConVarChange(sm_coc_thirdperson,	ConVarChange);
	HookConVarChange(sm_coc_slaytk,			ConVarChange);
	HookConVarChange(sm_coc_winordie,		ConVarChange);
	HookConVarChange(sm_coc_hpchicken,		ConVarChange);
	HookConVarChange(sm_coc_hpbonus,		ConVarChange);
	HookConVarChange(sm_coc_hpreward,		ConVarChange);
	HookConVarChange(sm_coc_burntime,		ConVarChange);
	HookConVarChange(sm_coc_timeleft,		ConVarChange);
	HookConVarChange(sm_coc_minrivals,		ConVarChange);
	HookConVarChange(sm_coc_maxrivals,		ConVarChange);
	HookConVarChange(sm_coc_mdl_cluckct,	ConVarChange);
	HookConVarChange(sm_coc_mdl_cluckt,		ConVarChange);
	HookConVarChange(sm_coc_mdl_clutchct,	ConVarChange);
	HookConVarChange(sm_coc_mdl_clutcht,	ConVarChange);
	HookConVarChange(sm_coc_msg_warn,		ConVarChange);
	HookConVarChange(sm_coc_msg_killdeath,	ConVarChange);
	HookConVarChange(sm_coc_msg_clutch,		ConVarChange);
	HookConVarChange(sm_coc_msg_windordie,	ConVarChange);
	HookConVarChange(sm_coc_version,		ConVarChange);
	
	cocenable	= GetConVarBool(sm_coc_enable);
	random		= GetConVarBool(sm_coc_random);
	ratio		= GetConVarInt(sm_coc_ratio);
	beacon		= GetConVarInt(sm_coc_beacon);
	knife		= GetConVarBool(sm_coc_knife);
	c4pickup	= GetConVarBool(sm_coc_c4pickup);
	thirdperson	= GetConVarBool(sm_coc_thirdperson);
	slaytk		= GetConVarBool(sm_coc_slaytk);
	winordie	= GetConVarInt(sm_coc_winordie);
	hpchicken	= GetConVarInt(sm_coc_hpchicken);
	hpbonus		= GetConVarInt(sm_coc_hpbonus);
	hpreward	= GetConVarInt(sm_coc_hpreward);
	burntime	= GetConVarFloat(sm_coc_burntime);
	timeleft	= GetConVarInt(sm_coc_timeleft);
	minrivals	= GetConVarInt(sm_coc_minrivals);
	maxrivals	= GetConVarInt(sm_coc_maxrivals);
	GetConVarString(sm_coc_mdl_cluckct, cluckCT, sizeof(cluckCT));
	GetConVarString(sm_coc_mdl_cluckt, cluckT, sizeof(cluckT));
	GetConVarString(sm_coc_mdl_clutchct, clutchCT, sizeof(clutchCT));
	GetConVarString(sm_coc_mdl_clutcht, clutchT, sizeof(clutchT));
	mWarn		= GetConVarBool(sm_coc_msg_warn);
	mKillDeath	= GetConVarBool(sm_coc_msg_killdeath);
	mClutch		= GetConVarBool(sm_coc_msg_clutch);
	mWinOrDie	= GetConVarBool(sm_coc_msg_windordie);
	
	g_EngineVersion = GetEngineVersion();
	
	LoadTranslations("common.phrases");
	//LoadTranslations("clutchorcluck.phrases");
	AutoExecConfig(true, "clutchorcluck");
	
	if (!FileExists(CHICKEN, true) && !FileExists(CHICKEN, false))
	{
		SetFailState("Chicken model missing: %s", CHICKEN);
	}
	else if (!StrEqual(cluckCT, "") && !FileExists(cluckCT, true) && !FileExists(cluckCT, false))
	{
		SetFailState("Missing model for sm_coc_mdl_cluckct: %s", cluckCT);
	}
	else if (!StrEqual(cluckT, "") && !FileExists(cluckT, true) && !FileExists(cluckT, false))
	{
		SetFailState("Missing model for sm_coc_mdl_cluckt: %s", cluckT);
	}
	else if (!StrEqual(clutchCT, "") && !FileExists(clutchCT, true) && !FileExists(clutchCT, false))
	{
		SetFailState("Missing model for sm_coc_mdl_clutchct: %s", clutchCT);
	}
	else if (!StrEqual(clutchT, "") && !FileExists(clutchT, true) && !FileExists(clutchT, false))
	{
		SetFailState("Missing model for sm_coc_mdl_clutcht: %s", clutchT);
	}
	else if (cocenable)
	{
		EnablePlugin();
	}
}

public OnConfigsExecuted()
{
	decl String:path[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, path, sizeof(path), "configs/clutchorcluck.ini");
	
	new Handle:file = OpenFile(path, "r");
	
	if (file != INVALID_HANDLE)
	{
		decl String:buffer[128];
		
		while (!IsEndOfFile(file) && ReadFileLine(file, buffer, sizeof(buffer)))
		{
			TrimString(buffer);
			
			if (FileExists(buffer))
			{
				AddFileToDownloadsTable(buffer);
				
				if (StrContains(buffer, ".mdl", false) >= 0)
				{
					PrecacheModel(buffer, true);
				}
			}
		}
	}
	
	CloseHandle(file);
	
	if (g_EngineVersion == Engine_CSS)
	{
		AddFileToDownloadsTable("materials/models/props_farm/chicken_white.vmt");
		AddFileToDownloadsTable("materials/models/props_farm/chicken_white.vtf");
		AddFileToDownloadsTable("models/chicken/chicken.dx90.vtx");
		AddFileToDownloadsTable("models/chicken/chicken.phy");
		AddFileToDownloadsTable("models/chicken/chicken.vvd");
		AddFileToDownloadsTable(CHICKEN);
		PrecacheModel(CHICKEN, true);
	}
}

public OnClientPutInServer(client)
{
	SDKHook(client, SDKHook_WeaponCanUse, OnWeaponCanUse);
}

EnablePlugin()
{
	if (thirdperson && g_EngineVersion == Engine_CSGO)
	{
		SetConVarBool(FindConVar("sv_allow_thirdperson"), true);
	}
	else
	{
		thirdperson = false;
	}
	
	HookEvent("round_start",		Event_RoundStart);
	HookEvent("round_freeze_end",	Event_RoundFreezeEnd);
	HookEvent("round_end",			Event_RoundEnd);
	HookEvent("player_spawn",		Event_Spawn);
	HookEvent("player_death",		Event_Death);
}

DisablePlugin()
{
	UnhookEvent("round_start",		Event_RoundStart);
	UnhookEvent("round_freeze_end",	Event_RoundFreezeEnd);
	UnhookEvent("round_end",		Event_RoundEnd);
	UnhookEvent("player_spawn",		Event_Spawn);
	UnhookEvent("player_death",		Event_Death);
}

public ConVarChange(Handle:cvar, const String:oldValue[], const String:newValue[])
{
	new nval = StringToInt(newValue);
	
	if (cvar == sm_coc_enable)
	{
		cocenable = (nval == 1) ? true : false;
		
		if (cocenable)
		{
			EnablePlugin();
		}
		else
		{
			DisablePlugin();
		}
	}
	else if (cvar == sm_coc_random)
	{
		random = (nval == 1) ? true : false;
	}
	else if (cvar == sm_coc_ratio)
	{
		ratio = nval;
	}
	else if (cvar == sm_coc_beacon)
	{
		beacon = nval;
	}
	else if (cvar == sm_coc_knife)
	{
		knife = (nval == 1) ? true : false;
	}
	else if (cvar == sm_coc_c4pickup)
	{
		c4pickup = (nval == 1) ? true : false;
	}
	else if (cvar == sm_coc_thirdperson)
	{
		if (g_EngineVersion == Engine_CSGO)
		{
			thirdperson = (nval == 1) ? true : false;
		}
	}
	else if (cvar == sm_coc_slaytk)
	{
		slaytk = (nval == 1) ? true : false;
	}
	else if (cvar == sm_coc_winordie)
	{
		winordie = nval;
	}
	else if (cvar == sm_coc_hpchicken)
	{
		hpchicken = nval;
	}
	else if (cvar == sm_coc_hpbonus)
	{
		hpbonus = nval;
	}
	else if (cvar == sm_coc_hpreward)
	{
		hpreward = nval;
	}
	else if (cvar == sm_coc_burntime)
	{
		burntime = StringToFloat(newValue);
	}
	else if (cvar == sm_coc_timeleft)
	{
		timeleft = nval;
	}
	else if (cvar == sm_coc_minrivals)
	{
		minrivals = nval;
	}
	else if (cvar == sm_coc_maxrivals)
	{
		maxrivals = nval;
	}
	else if (cvar == sm_coc_mdl_cluckct)
	{
		GetConVarString(cvar, cluckCT, sizeof(cluckCT));
	}
	else if (cvar == sm_coc_mdl_cluckt)
	{
		GetConVarString(cvar, cluckT, sizeof(cluckT));
	}
	else if (cvar == sm_coc_mdl_clutchct)
	{
		GetConVarString(cvar, clutchCT, sizeof(clutchCT));
	}
	else if (cvar == sm_coc_mdl_clutcht)
	{
		GetConVarString(cvar, clutchT, sizeof(clutchT));
	}
	else if (cvar == sm_coc_msg_warn)
	{
		mWarn = (nval == 1) ? true : false;
	}
	else if (cvar == sm_coc_msg_killdeath)
	{
		mKillDeath = (nval == 1) ? true : false;
	}
	else if (cvar == sm_coc_msg_clutch)
	{
		mClutch = (nval == 1) ? true : false;
	}
	else if (cvar == sm_coc_msg_windordie)
	{
		mWinOrDie = (nval == 1) ? true : false;
	}
	else if (cvar == sm_coc_version)
	{
		SetConVarString(cvar, PLUGIN_VERSION);
	}
}

public Action:Command_Chicken(client, args)
{
	if (args < 1)
	{
		ReplyToCommand(client, "[SM] Usage: sm_chicken <#userid|name>");
	}
	else
	{
		decl String:arg[65];
		GetCmdArg(1, arg, sizeof(arg));
		
		decl String:target_name[MAX_TARGET_LENGTH];
		decl target_list[MAXPLAYERS], target_count, bool:tn_is_ml;
		
		if ((target_count = ProcessTargetString(
				arg,
				client,
				target_list,
				MAXPLAYERS,
				COMMAND_FILTER_ALIVE,
				target_name,
				sizeof(target_name),
				tn_is_ml)) <= 0)
		{
			ReplyToTargetError(client, target_count);
		}
		else
		{
			for (new i = 0; i < target_count; i++)
			{
				if (IsClientInGame(target_list[i]) && IsPlayerAlive(target_list[i]))
				{
					SetEntityModel(target_list[i], CHICKEN);
					PrintCenterText(target_list[i], "You are a rambo chicken.");
				}
			}
		}
	}
	return Plugin_Handled;
}

public Action:OnPlayerRunCmd(client, &buttons, &impulse, Float:vel[3], Float:angles[3], &weapon)
{
	if (cocenable && thirdperson && IsClientInGame(client) && IsPlayerAlive(client))
	{
		new id = GetClientUserId(client);
		
		if (chickenId == id)
		{
			if ((buttons & IN_RELOAD) && !(lastButton & IN_RELOAD))
			{
				ClientCommand(client, tp ? "firstperson" : "thirdperson");
				tp = !tp;
			}
			lastButton = buttons;
		}
		else if (chickenIdOld == id)
		{
			if ((buttons & IN_RELOAD) && !(lastButtonOld & IN_RELOAD))
			{
				ClientCommand(client, tpOld ? "firstperson" : "thirdperson");
				tpOld = !tpOld;
			}
			lastButtonOld = buttons;
		}
	}
	return Plugin_Continue;
}

public Action:OnWeaponCanUse(client, weapon)
{
	if (cocenable)
	{
		new id = GetClientUserId(client);
		
		if (chickenId == id || chickenIdOld == id)
		{
			decl String:wname[32]; 
			GetEdictClassname(weapon, wname, sizeof(wname));
			
			if (!((knife && StrEqual(wname, "weapon_knife", false)) || (c4pickup && StrEqual(wname, "weapon_c4", false))))
			{
				return Plugin_Handled;
			}
		}
	}
	return Plugin_Continue;
}

public Action:CS_OnBuyCommand(client, const String:weapon[])
{
	if (cocenable && IsPlayerAlive(client))
	{
		new id = GetClientUserId(client);
		
		if (chickenId == id || chickenIdOld == id)
		{
			PrintCenterText(client, "Chickens are not allowed to buy.");
			return Plugin_Handled;
		}
	}
	return Plugin_Continue;
}

public Action:Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	roundTime = GetEventInt(event, "timelimit");
	displayed = false;
	roundend = false;
}

public Action:Event_RoundFreezeEnd(Handle:event, const String:name[], bool:dontBroadcast)
{
	savedTime = GetTime();
	
	if (playerId != 0 && !clutch && !cluck)
	{
		new client = GetClientOfUserId(playerId);
		
		if (client != 0 && IsClientInGame(client) && IsPlayerAlive(client))
		{
			IgniteEntity(client, burntime);
			
			if (mClutch)
			{
				PrintToChatAll("\x01[COC]\x04 %s has been set on fire for failing to clutch.", playerName);
			}
		}
		playerId = 0;
	}
}

public Action:Event_RoundEnd(Handle:event, const String:name[], bool:dontBroadcast)
{	
	roundend = true;
	
	new winner = GetEventInt(event, "winner");
	
	if (displayed && playerId != 0 && !cluck)
	{
		new client = GetClientOfUserId(playerId);
		
		if (client != 0 && IsClientInGame(client))
		{
			if (GetClientTeam(client) == winner)
			{
				if (mClutch)
				{
					PrintToChatAll("\x01[COC]\x04 %s clutched the round against %d opponents! (%d HP remaining)", playerName, rivals, GetClientHealth(client));
				}
				clutch = true;
			}
			else
			{
				if (mClutch)
				{
					PrintToChatAll("\x01[COC]\x04 %s pathetically failed to clutch against %d opponents.", playerName, rivals);
				}
				clutch = false;
			}
		}
	}
	
	if (winordie > 0 && winner > 1)
	{		
		if (GetEventInt(event, "reason") == 0)
		{
			CreateTimer(0.10, C4Explode);
		}
		else
		{
			SlayLosers(winner);
		}
	}
	
	chickenId = 0;
	chickenIdOld = 0;
	displayed = false;
}

public Action:C4Explode(Handle:timer)
{
	SlayLosers(2);
	return Plugin_Stop;
}

SlayLosers(winner)
{
	new bool:slayed = false;
	
	for (new client = 1; client <= MaxClients; client++)
	{
		if (roundend && IsClientInGame(client) && IsPlayerAlive(client) && GetClientTeam(client) != winner)
		{
			new id = GetClientUserId(client);
			
			if (GetClientHealth(client) >= winordie || id == chickenId || id == chickenIdOld)
			{
				ForcePlayerSuicide(client);
				slayed = true;
			}
			else
			{
				PrintHintText(client, "You have been spared for trying...");
			}
		}
	}
	
	if (mWinOrDie && (!displayed || cluck) && slayed)
	{
		PrintToChatAll("\x01[COC]\x04 %s slayed for failing to do the objective in time.", (winner == TEAM_T) ? "Counter-Terrorists" : "Terrorists");
	}
}

public Action:Event_Spawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new spawnId = GetEventInt(event, "userid");
	new client = GetClientOfUserId(spawnId);
	
	if (thirdperson)
	{
		ClientCommand(client, "firstperson");
	}
	
	if ((clutch || cluck) && playerId == spawnId)
	{		
		if (clutch)
		{
			if (hpreward != 100)
			{
				SetEntityHealth(client, hpreward);
				
				if (mClutch)
				{
					PrintToChatAll("\x01[COC]\x04 %s is rewarded with %d HP for clutching.", playerName, hpreward);
				}
			}
		}
		else
		{
			SetCluck(client);
			
			if (mWarn)
			{
				PrintToChatAll("\x01[COC]\x04 %s is still a chicken for this round...", playerName);
			}
		}
		
		playerId = 0;
		clutch = false;
		cluck = false;
	}
}

public Action:Event_Death(Handle:event, const String:name[], bool:dontBroadcast)
{
	new died = GetEventInt(event, "userid");
	new dclient = GetClientOfUserId(died);
	
	if (g_EngineVersion == Engine_CSGO)
	{
		decl String:dmodel[64];
		GetClientModel(dclient, dmodel, sizeof(dmodel));
		
		if (StrEqual(dmodel, CHICKEN, false))
		{
			SetEntityModel(dclient, FEATHERS);
		}
		
		if (thirdperson)
		{
			ClientCommand(dclient, "firstperson");
		}
	}
	
	if (chickenId != 0)
	{
		new killer = GetEventInt(event, "attacker");
		
		if (killer != died)
		{
			new kclient = GetClientOfUserId(killer);
			new bool:slayed = false;
			
			if (slaytk && kclient > 0 && (chickenId == died || chickenIdOld == died) && GetClientTeam(kclient) == GetClientTeam(dclient) && IsPlayerAlive(kclient))
			{
				CreateTimer(0.0, SlayTimer, kclient);
				slayed = true;
			}
			
			if (mKillDeath)
			{
				if (chickenId == died || chickenIdOld == died)
				{
					if (killer == 0)
					{
						PrintToChatAll("\x01[COC]\x04 %s chicken tried to fly.", (chickenIdOld == 0) ? "The" : "A");
					}
					else if ((chickenId == killer && chickenIdOld == died) || (chickenIdOld == killer && chickenId == died))
					{
						PrintToChatAll("\x01[COC]\x04 A chicken has dominated an enemy chicken.");
					}
					else if (slayed)
					{
						decl String:kname[32];
						GetClientName(kclient, kname, sizeof(kname));
						PrintToChatAll("\x01[COC]\x04 %s has been slayed for killing a friendly chicken.", kname);
					}
					else
					{
						PrintToChatAll("\x01[COC]\x04 %s chicken has been killed.", (chickenIdOld == 0) ? "The" : "A");
					}
				}
				else if (chickenId == killer || chickenIdOld == killer)
				{
					decl String:dname[32];
					GetClientName(dclient, dname, sizeof(dname));
					PrintToChatAll("\x01[COC]\x04 %s was killed by a chicken.", dname);
				}
			}
		}
		
		if (chickenId == died)
		{
			chickenId = 0;
		}
	}
	
	if (!displayed && !roundend && EnoughTimeLeft())
	{
		aliveT = 0, aliveCT = 0;
		
		for (new client = 1; client <= MaxClients; client++)
		{
			if (IsClientInGame(client) && IsPlayerAlive(client))
			{
				switch (GetClientTeam(client))
				{
					case TEAM_T:
					{
						aliveT++;
					}
					case TEAM_CT:
					{
						aliveCT++;
					}
				}
			}
		}
		
		if ((aliveT == 1 && aliveCT >= minrivals && aliveCT <= maxrivals) || (aliveCT == 1 && aliveT >= minrivals && aliveT <= maxrivals))
		{
			for (new client = 1; client <= MaxClients; client++)
			{
				if (IsClientInGame(client) && IsPlayerAlive(client) && !IsFakeClient(client))
				{
					if ((aliveT == 1 && GetClientTeam(client) == TEAM_T) || (aliveCT == 1 && GetClientTeam(client) == TEAM_CT))
					{
						rivals = aliveT + aliveCT - 1;
						
						if (chickenId == GetClientUserId(client) || (random && ratio < GetRandomInt(1, 100)))
						{
							displayed = true;
							SetClutch(client);
							
							if (mWarn)
							{
								PrintToChatAll("\x01[COC]\x04 %s clutch or burn!", (chickenId == playerId) ? "Chicken" : playerName);
							}
						}
						else if (random)
						{
							displayed = true;
							SetCluck(client);
							
							if (mWarn)
							{
								PrintToChatAll("\x01[COC]\x04 %s has randomly turned into a chicken.", playerName);
							}
						}
						else
						{
							new Handle:menu = CreateMenu(MenuHandler);
							SetMenuTitle(menu, "Clutch or Cluck?");
							AddMenuItem(menu, "clutch", "Clutch");
							AddMenuItem(menu, "cluck", "Cluck");
							SetMenuExitButton(menu, false);
							displayed = DisplayMenu(menu, client, 10);
						}
					}
				}
			}
		}
	}
}

public Action:SlayTimer(Handle:timer, any:client)
{
	ForcePlayerSuicide(client);
	return Plugin_Stop;
}

public MenuHandler(Handle:menu, MenuAction:action, param1, param2)
{	
	switch (action)
	{
		case MenuAction_Select:
		{
			if (displayed && EnoughTimeLeft() && IsPlayerAlive(param1))
			{				
				if (param2 == 0)
				{
					SetClutch(param1);
					
					if (mWarn)
					{
						PrintToChatAll("\x01[COC]\x04 Clutch or burn initiated by %s.", playerName);
					}
				}
				else
				{
					SetCluck(param1);
					
					if (mWarn)
					{
						PrintToChatAll("\x01[COC]\x04 %s chose to be a cowardly chicken. Find and kill him!", playerName);
					}
				}
			}
			else
			{
				cluck = false;
				displayed = false;
				PrintHintText(param1, "Too late! You ran out of time...");
			}
		}
		case MenuAction_Cancel:
		{
			if (displayed && EnoughTimeLeft() && IsClientInGame(param1) && IsPlayerAlive(param1) && param2 == MenuCancel_Timeout)
			{
				SetCluck(param1);
				
				if (mWarn)
				{
					PrintToChatAll("\x01[COC]\x04 %s failed to pick an option and has now turned into a chicken.", playerName);
				}
			}
		}
		case MenuAction_End:
		{
			CloseHandle(menu);
		}
	}
}

bool:EnoughTimeLeft()
{
	return ((roundTime - (GetTime() - savedTime)) > timeleft && roundTime < 999);
}

SetPlayerInfo(client)
{
	playerId = GetClientUserId(client);
	GetClientName(client, playerName, sizeof(playerName));
}

SetClutch(client)
{
	cluck = false;
	SetPlayerInfo(client);
	
	SetEntityHealth(client, hpbonus);
	
	if (chickenId != playerId)
	{
		if (!StrEqual(clutchCT, "") && GetClientTeam(client) == TEAM_CT)
		{
			SetEntityModel(client, clutchCT);
		}
		else if (!StrEqual(clutchT, "") && GetClientTeam(client) == TEAM_T)
		{
			SetEntityModel(client, clutchT);
		}
	}
	
	if (beacon == 1 || beacon == 3)
	{
		ServerCommand("sm_beacon #%d", GetClientUserId(client));
	}
}

SetCluck(client)
{
	cluck = true;
	SetPlayerInfo(client);
	
	if (chickenId != 0 && chickenId != playerId)
	{
		new old = GetClientOfUserId(chickenId);
		
		if (old != 0 && IsClientInGame(client) && IsClientInGame(old) && IsPlayerAlive(client) && IsPlayerAlive(old))
		{
			PrintToChat(client, "\x01[COC]\x04 Enemy chicken detected!");
			PrintToChat(old, "\x01[COC]\x04 Enemy chicken detected!");
		}
		
		chickenIdOld = chickenId;
	}
	
	chickenId = playerId;
	SetEntityHealth(client, hpchicken);
	
	if (!StrEqual(cluckCT, "") && GetClientTeam(client) == TEAM_CT)
	{
		SetEntityModel(client, cluckCT);
	}
	else if (!StrEqual(cluckT, "") && GetClientTeam(client) == TEAM_T)
	{
		SetEntityModel(client, cluckT);
	}
	
	for (new weapon, i = 0; i < 5; i++)
	{
		if (knife && i == 2) { continue; }
		if (c4pickup && i == 4) { continue; }
		
		while ((weapon = GetPlayerWeaponSlot(client, i)) != -1)
		{
			CS_DropWeapon(client, weapon, true, false);
		}
	}
	
	if (beacon == 2 || beacon == 3)
	{
		ServerCommand("sm_beacon #%d", GetClientUserId(client));
	}
	else
	{
		PrintCenterText(client, "You are a stealthy chicken!\nPress RELOAD key to toggle view.");
	}
}